## opencpn 5.6.2%2Bdfsg

=== libs/wxcurl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if (TARGET ocpn::wxcurl)
    return ()
endif ()

if (POLICY CMP0077)
    CMAKE_POLICY(SET CMP0077 OLD)
endif ()

if (NOT CMAKE_MODULE_PATH)
  set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()


set(SRC
    src/base.cpp
    src/dav.cpp
    src/davtool.cpp
    src/dialog.cpp
    src/ftp.cpp
    src/http.cpp
    src/include
    src/panel.cpp
    src/telnet.cpp
    src/thread.cpp
    src/utils.cpp
    include/wx/curl/base.h
    include/wx/curl/dav.h
    include/wx/curl/davtool.h
    include/wx/curl/dialog.h
    include/wx/curl/ftp.h
    include/wx/curl/http.h
    include/wx/curl/panel.h
    include/wx/curl/telnet.h
    include/wx/curl/thread.h
    include/wx/curl/utils.h
)

if (NOT wxWidgets_INCLUDE_DIRS)
    include(SimpleWxConfig)
    SimpleWxConfig()
endif ()

include(Curl)

add_library(WXCURL STATIC ${SRC})
add_library(ocpn::wxcurl ALIAS WXCURL)
set_property(TARGET WXCURL PROPERTY COMPILE_FLAGS "-fvisibility=default")
target_include_directories(WXCURL
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
    PUBLIC ${CURL_INCLUDE_DIRS}
)
target_link_libraries(WXCURL ${CURL_LIBRARIES})
if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|AppleClang|GNU")
  target_compile_options(WXCURL  PRIVATE "-Wno-unknown-pragmas")
endif ()
if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|AppleClang")
    target_compile_options(WXCURL PRIVATE "-Wno-varargs")
endif()

=== debian/changelog ===
opencpn (5.6.2+dfsg-1~bpo11+3) bullseye-backports; urgency=medium

  *  Add patch for long delays when exiting. Closes: #1032296

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 03 Mar 2023 09:19:40 +0100

opencpn (5.6.2+dfsg-1~bpo11+2) bullseye-backports; urgency=medium

  * Add patch fur unusable buildd version. Closes: #1010860

 -- Alec Leamas <leamas.alec@gmail.com>  Wed, 11 May 2022 21:06:26 +0200

opencpn (5.6.2+dfsg-1~bpo11+1) bullseye-backports; urgency=medium

  * Initial bullseye backport of 5.6.2+dfsg-1

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 26 Apr 2022 15:06:54 +0200

opencpn (5.6.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove upstream debian packaging in source tarball.
  * Add patch for wrong desktop filename (tracker.debian.org warning).
  * d/rules: Add explicit CMAKE_BUILD_TYPE setting (upstream discussion
    in https://github.com/OpenCPN/OpenCPN/issues/2612)
  * d/watch: dfsg1 -> dfsg (lintian warning)
  * d/control: Add missing -b branch to Vcs-Git:
  * d/control: Make opencpn-data Multi-arch: foreign (tracker.debian.org
    warning).
  * d/copyright: Remove unused GPL-2 license.

 -- Alec Leamas <leamas.alec@gmail.com>  Mon, 25 Apr 2022 22:44:41 +0200

=== debian/rules ===
#!/usr/bin/make -f

include  /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=RelWithDebInfo \
   	    -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_INSTALL_LIBDIR=/usr/lib \
            -DBUILD_SHARED_LIBS=OFF \
	    -DOCPN_BUNDLE_DOCS=OFF \
            -DOCPN_BUNDLE_TCDATA=ON \
            -DOCPN_USE_BUNDLED_LIBS=OFF \
            -DOCPN_USE_NEWSERIAL=OFF \
            -DOCPN_PLUGIN_CONTENTS_WARN=ON \
            -DOCPN_FORCE_GTK3=ON

## opencpn 5.6.2+dfsg

=== CMakeLists.txt ===
# ---------------------------------------------------------------------------
# Author:      Dave Register DEB
# config from: antonm - Anton Martchukov <anton@martchukov.com>
# Update:      sethdart (Jean-Eudes Onfray)
#                 with parts from balp (Anders Arnholm)
# ***************************************************************************
# - Copyright (C) 2010 by David S. Register                               *
# - This program is free software; you can redistribute it and/or modify  *
# - it under the terms of the GNU General Public License as published by  *
# - the Free Software Foundation; either version 2 of the License, or     *
# - (at your option) any later version.                                   *
# - *
# - This program is distributed in the hope that it will be useful,       *
# - but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# - GNU General Public License for more details.                          *
# - *
# - You should have received a copy of the GNU General Public License     *
# - along with this program; if not, write to the                         *
# - Free Software Foundation, Inc.,                                       *
# - 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.         *
# ***************************************************************************

#[[
TODO:
- Profiling opt
- test with Win & OSX
USE_GLU_TESS
USE_GLU_DLL
I also find it deficient in some areas. For instance, I cannot make it
output a VS project with certain compile switches set as desired,
namely /MT vs /MD. This means I must manually set this and other compiler
options after the CMake step. Sometimes I forget. Grrr...
set /MT for Release build, and /MTd for debug.
Is this still problem? If so, generator expressions seem to be the solution.
#]]

cmake_minimum_required(VERSION 3.1.1)
cmake_policy(SET CMP0043 NEW)
cmake_policy(SET CMP0025 NEW)
if (POLICY CMP0057)
  cmake_policy(SET CMP0057 NEW)
endif ()
if (POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif ()

# Prefer libGL.so to libOpenGL.so, see CMP0072
set(OpenGL_GL_PREFERENCE "LEGACY")

if (APPLE)
  set(PACKAGE_NAME OpenCPN)
else (APPLE)
  set(PACKAGE_NAME opencpn)
endif (APPLE)

if ("${OCPN_TARGET_TUPLE}" MATCHES "Android")
   message(STATUS "Building for wxQt-Android")
   set( CMAKE_TOOLCHAIN_FILE buildandroid/build_android.cmake)
   set(QT_ANDROID "ON")
   if ("${OCPN_TARGET_TUPLE}" MATCHES "Android-arm64")
     add_definitions("-DANDROID_ARM64")
   else ()
     add_definitions("-DANDROID_ARMHF")
   endif ()
   set(PACKAGE_NAME gorp)
endif ()


project(OpenCPN)

if (NOT DEFINED OCPN_VERBOSE OR OCPN_VERBOSE)
  set(CMAKE_VERBOSE_MAKEFILE ON)
endif ()

message(STATUS "cmake version: ${CMAKE_VERSION}")

# Locations where cmake looks for cmake modules.
set(
  CMAKE_MODULE_PATH
  ${CMAKE_SOURCE_DIR}/build
  ${CMAKE_SOURCE_DIR}/
  ${CMAKE_SOURCE_DIR}/cmake
)



include(FindPkgConfig)
include(CMakeDependentOption)
include(CheckSymbolExists)

if (QT_ANDROID)
  #include(libs/AndroidLibs.cmake)
endif ()

#
# Options
#

macro (BUNDLE_DOCS_OPT onoff)
  option(OCPN_BUNDLE_DOCS "Include documentation in package" ${onoff})
endmacro (BUNDLE_DOCS_OPT)

macro (BUNDLE_TCDATA_OPT onoff)
  option(
    OCPN_BUNDLE_TCDATA "Include tide/current harmonics data in package"
    ${onoff}
  )
endmacro (BUNDLE_TCDATA_OPT)

macro (BUNDLE_GSHHS_OPT onoff)
    option(OCPN_BUNDLE_GSHHS "Bundle minimal GSHHS data files" ${onoff})
endmacro (BUNDLE_GSHHS_OPT)

# If on Windows or Apple, build the monolithic package, to override use a non-
# sense values from the commandline (due to cmake inability to distinguish
# between not set and set to FALSE): cmake -DOCPN_BUNDLE_DOCS=BLAH
# -DOCPN_BUNDLE_TCDATA=BLAH

# Bundle tcdata and gshhs by default also on linux, to keep the defaults
# close to the official Debian package.
bundle_gshhs_opt("ON")
bundle_tcdata_opt("ON")

if (APPLE OR WIN32)
  bundle_docs_opt("ON")
else (APPLE OR WIN32)
  bundle_docs_opt("OFF")
endif (APPLE OR WIN32)


option(OCPN_VERBOSE "Make verbose builds"  ON)
option(OCPN_PEDANTIC "Enable more compiler warnings" OFF)

set(OCPN_PACKAGE_RELEASE "1" CACHE STRING "Package release number")

option(OCPN_USE_GL "Enable OpenGL support" ON)
option(OCPN_USE_GLES_SHIM "Enable GLESv1 Shim library" OFF)
option(OCPN_USE_UDEV_PORTS "Use udev to enumerate serial ports" ON)
option(OCPN_USE_SYSFS_PORTS "Use sysfs to enumerate serial ports" OFF)

set(OCPN_TARGET_TUPLE "" CACHE STRING
  "List of target;version;arch like flatpak;20.08;aarch64 [\"\"]"
)

if (MSVC OR MINGW)
  option(OCPN_USE_CRASHREPORT "Enable crash reporting" ON)
else ()
  set(OCPN_USE_CRASHREPORT FALSE)
endif ()

if (NOT WIN32 AND NOT APPLE AND NOT QT_ANDROID)
  find_library(GTK2U NAMES wx_gtk2u_core)
  if (GTK2U)
    option(OCPN_FORCE_GTK3 "Force the build to use GTK3 [OFF]" "OFF")
  else ()
    option(OCPN_FORCE_GTK3 "Force the build to use GTK3 [ON]" "ON")
  endif ()
endif ()

if (WIN32 OR APPLE OR QT_ANDROID)
  set(PA_DEFAULT "OFF")
else ()
  set(PA_DEFAULT "ON")
endif ()
option(
  OCPN_ENABLE_PORTAUDIO "Use portaudio(3) to play sounds if available"
  ${PA_DEFAULT}
)
cmake_dependent_option(
  OCPN_ENABLE_SNDFILE "Use libsndfile for portaudio if available."
  ON "OCPN_ENABLE_PORTAUDIO" ON
)

option(OCPN_USE_GARMINHOST "Enable Garmin Host Mode support" ON)

set(
  OCPN_WXWIDGETS_FORCE_VERSION
  CACHE STRING "Force usage of a specific wxWidgets version."
)

set(
  OCPN_WXWIDGETS_OPTIONS
  CACHE STRING "Additional flags to wxWidgets_CONFIG_OPTIONS"
)

if (WIN32 AND NOT UNIX)
  option(OCPN_BUNDLE_WXDLLS "Bundle the prebuilt WX DLLs" ON)
  option(OCPN_BUNDLE_VCDLLS "Bundle the VC redistributable libraries" ON)
  option(
    BUNDLE_LIBARCHIVEDLLS "Bundle the prebuilt LibArchive and LibLZMA DLLs" ON
  )
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  option(OCPN_ENABLE_CLANG_TIDY "Add clang-tidy automatically to builds" OFF)
  set(ENABLE_SANITIZER "none" CACHE STRING "Add clang sanitizer to the build")
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.9)
  option(OCPN_ENABLE_CPPCHECK "Add cppcheck automatically to builds" OFF)
endif ()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE RelWithDebInfo
    CACHE
      STRING
      "Choose type of build: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE
  )
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)

if (APPLE)
  option(OCPN_USE_LIBCPP "Use libc++ instead of libstdc++ on macOS" ON)
endif ()

option(OCPN_USE_EXTERN_CURL "Use external libcurl" OFF)

if (NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX ${TENTATIVE_PREFIX})
endif (NOT CMAKE_INSTALL_PREFIX)

if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(BUNDLED_LIBS_DEFAULT "ON")
else ()
  set(BUNDLED_LIBS_DEFAULT "OFF")
endif ()
set(
  OCPN_USE_BUNDLED_LIBS ${BUNDLED_LIBS_DEFAULT}
  CACHE
    STRING
    "Use bundled libraries instead of system's [ON, OFF or comma-sep list]"
)

option(OCPN_USE_NEWSERIAL "Use new serial communication implementation" ON)
option(OCPN_USE_CURL "Use Curl libraries" ON)
option(OCPN_USE_SVG "Use SVG graphics" ON)
option(OCPN_USE_WEBVIEW "Use wxWidget's webview addon if available" ON)
option(OCPN_USE_LZMA "Use LZMA for chart compression" ON)
option(OCPN_CI_BUILD "Use CI build versioning rules" OFF)
option(OCPN_USE_SYSTEM_LIBARCHIVE "Use the libarchive version provided by the system on MacOS" ON)

if (WIN32)
  set(cmd_snd_default OFF)
else ()
  set(cmd_snd_default ON)
endif ()

option(
  OCPN_ENABLE_SYSTEM_CMD_SOUND
  "Use aplay(1), afplay(1) etc. to play sounds if available" ${cmd_snd_default}
)
set(OCPN_SOUND_CMD "" CACHE STRING
  "Hardcoded value for CLI command used in SystemCmdSound backend"
)

if (UNIX AND NOT APPLE AND NOT QT_ANDRIOD)
  set(LINUX "1")
endif ()

if (QT_ANDROID)
  set(OCPN_NEW_SERIAL OFF)
  set(OCPN_USE_NEWSERIAL OFF)
  set(OCPN_USE_CURL ON)
  set(OCPN_USE_LZMA OFF)
endif (QT_ANDROID)

# Check if a given library should use the bundled source
macro (USE_BUNDLED_LIB _result library)
  if ("${OCPN_USE_BUNDLED_LIBS}" STREQUAL "")
    set(OCPN_USE_BUNDLED_LIBS "ON")
  endif ()
  if (${OCPN_USE_BUNDLED_LIBS} STREQUAL "OFF")
    set(${_result} "OFF")
  elseif (${OCPN_USE_BUNDLED_LIBS} STREQUAL "ON")
    set(${_result} "ON")
  elseif (",${OCPN_USE_BUNDLED_LIBS}," MATCHES ",${library},")
    set(${_result} "ON")
  else ()
    set(${_result} "OFF")
  endif ()
endmacro (USE_BUNDLED_LIB)

#
# Language, compiler and static checkers setup
#

include(GetArch)
getarch()
message(STATUS "*** Host Build Architecture is ${ARCH}")

set(CMAKE_CXX_STANDARD 11)
message(STATUS "Setting C++11 standard via cmake standard mechanism")
if (NOT MSVC)
  set(OBJ_VISIBILITY "-fvisibility=hidden")
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  if (OCPN_ENABLE_CLANG_TIDY)
    find_program(
      CLANG_TIDY_EXE
      NAMES "clang-tidy"
      PATHS /usr/local/opt/llvm/bin
    )
    if (CLANG_TIDY_EXE)
      message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
      # For more, see http://clang.llvm.org/extra/clang-tidy/
      # set(CLANG_TIDY_CHECKS "-*,modernize-*")
      set(CLANG_TIDY_CHECKS "-*,performance-*")
      set(
        CMAKE_CXX_CLANG_TIDY
        "${CLANG_TIDY_EXE};-checks=${CLANG_TIDY_CHECKS};-header-filter='${CMAKE_SOURCE_DIR}/*'"
        CACHE STRING ""
        FORCE
      )
    else ()
      message(AUTHOR_WARNING "clang-tidy not found!")
      set(CMAKE_CXX_CLANG_TIDY "" CACHE STRING "" FORCE) # delete it
    endif ()
  endif ()
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.4)
  # Add support for address etc sanitizers, part 1/2 (other half after
  # ADD_EXECUTABLE)
  set_property(
    CACHE ENABLE_SANITIZER
    PROPERTY
      STRINGS
      none
      address
      memory
      thread
      undefined
  )
  if (NOT "${ENABLE_SANITIZER}" MATCHES "none")
    add_compile_options(-fsanitize=${ENABLE_SANITIZER})
  endif ()
endif ()

if (CMAKE_VERSION VERSION_GREATER 3.9)
  if (OCPN_ENABLE_CPPCHECK)
    find_program(CPPCHECK_EXECUTABLE NAMES "cppcheck")
    set(CMAKE_CXX_CPPCHECK ${CPPCHECK_EXECUTABLE})
  endif ()
endif ()

message(STATUS "Default compiler options:")
message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
message(STATUS "CMAKE_CXX_FLAGS_DEBUG: ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "CMAKE_CXX_FLAGS_MINSIZEREL: ${CMAKE_CXX_FLAGS_MINSIZEREL}")
message(STATUS "CMAKE_CXX_FLAGS_RELEASE: ${CMAKE_CXX_FLAGS_RELEASE}")
message(
  STATUS "CMAKE_CXX_FLAGS_RELWITHDEBINFO: ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}"
)

# ADD_COMPILE_OPTIONS( "-Wall" "-ansi" "-pedantic" "-Wno-variadic-macros" )
# TODO: Should we use  -fno-stack-protector IF NOT DEBUGGING CFLAGS="-O2
# -march=native"
if (NOT WIN32 AND NOT APPLE)
  add_compile_options("-Wall")
  if (NOT OCPN_PEDANTIC)
    add_compile_options(
      "-Wno-unused"
      "-fexceptions"
      "-rdynamic"
      "-fno-strict-aliasing"
      "-Wno-deprecated-declarations"
    )
  endif ()
  if (CMAKE_BUILD_TYPE MATCHES "Debug")
    add_compile_options("-O0")
  endif ()

  add_definitions(" -DPREFIX=\\\"${CMAKE_INSTALL_PREFIX}\\\"")
  # profiling with gprof ADD_COMPILE_OPTIONS( -pg ) SET(CMAKE_EXE_LINKER_FLAGS
  # -pg) profiling with gcov ADD_COMPILE_OPTIONS( "-fprofile-arcs -ftest-
  # coverage" ) SET(EXTRA_LIBS ${EXTRA_LIBS} "gcov")
endif (NOT WIN32 AND NOT APPLE)

if (MINGW)
  add_compile_options("-Wall")
  if (NOT OCPN_PEDANTIC)
    add_compile_options(
      "-Wno-unused"
      "-Wno-cpp"
      "-fexceptions"
      "-fno-strict-aliasing"
    )
  endif ()
  add_definitions("-DPSAPI_VERSION=1")
  add_definitions("-DUNICODE" "-D_UNICODE")
endif (MINGW)

if (APPLE)
  add_compile_options("-Wall")
  if (NOT OCPN_PEDANTIC)
    add_compile_options(
      "-Wno-unused"
      "-fexceptions"
      "-Wno-overloaded-virtual"

=== plugins/CMakeLists.txt ===
# ---------------------------------------------------------------------------
# Author:      Dave Register DEB config from: antonm - Anton Martchukov
# <anton@martchukov.com>
# ***************************************************************************
# - Copyright (C) 2010 by David S. Register                               *
# - This program is free software; you can redistribute it and/or modify  *
# - it under the terms of the GNU General Public License as published by  *
# - the Free Software Foundation; either version 2 of the License, or     *
# - (at your option) any later version.                                   *
# - *
# - This program is distributed in the hope that it will be useful,       *
# - but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# - GNU General Public License for more details.                          *
# - *
# - You should have received a copy of the GNU General Public License     *
# - along with this program; if not, write to the                         *
# - Free Software Foundation, Inc.,                                       *
# - 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.             *
# ***************************************************************************

CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
MESSAGE (STATUS "*** Staging to build PlugIns ***")
# These variables are inherited by all plugins
set(PARENT opencpn)
set(PREFIX_DATA share)
set(PREFIX_PLUGINS ${PREFIX_LIB}/${PARENT})

set(STANDALONE "BUNDLED")

file(GLOB PLUGINS *_pi)

foreach (PLUGIN ${PLUGINS})
  add_subdirectory(${PLUGIN})
  message(STATUS "*** Added plugin: ${PLUGIN}")
endforeach (PLUGIN)

option(OCPN_BUILD_SAMPLE "Build sample plugin" OFF)

if (OCPN_BUILD_SAMPLE)
  file(GLOB PLUGINS_SAMPLE *_pi_sample)

  foreach (PLUGIN ${PLUGINS_SAMPLE})
    add_subdirectory(${PLUGIN})
    message(STATUS "*** Added sample plugin: ${PLUGIN}")
  endforeach (PLUGIN)
endif (OCPN_BUILD_SAMPLE)

=== libs/easywsclient/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if (TARGET ocpn::easywsclient)
    return ()
endif ()

set(SRC easywsclient.cpp)

add_library(EASYWSCLIENT STATIC ${SRC})
add_library(ocpn::easywsclient ALIAS EASYWSCLIENT)

set_property(TARGET EASYWSCLIENT PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(EASYWSCLIENT PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

if (WIN32)
  target_link_libraries(EASYWSCLIENT PRIVATE ws2_32)
endif ()

=== libs/garmin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if (TARGET ocpn::garminhost)
    return ()
endif ()

# Build the garmin lib, once upon a time copied from gpslib. Needs
# a -DwxWidgets_INCLUDE_DIRS if built  separately.

set( SRC
    jeeps/gpsapp.c
    jeeps/gpscom.c
    jeeps/gpsmath.c
    jeeps/gpsmem.c
    jeeps/gpsprot.c
    jeeps/gpsread.c
    jeeps/gpsdevice.c
    jeeps/gpsdevice_ser.c
    jeeps/gpsdevice_usb.c
    jeeps/gpsrqst.c
    jeeps/gpssend.c
    jeeps/gpsserial.c
    jeeps/gpsutil.c
    jeeps/gpsusbread.c
    jeeps/gpsusbsend.c
    jeeps/gpsusbcommon.c
    jeeps/garmin_gps.h
    jeeps/gpsapp.h
    jeeps/gpsdatum.h
    jeeps/gpsfmt.h
    jeeps/gpsmath.h
    jeeps/gpsport.h
    jeeps/gpsprot.h
    jeeps/gpsrqst.h
    jeeps/gpsserial.h
    jeeps/gpsusbint.h
    jeeps/gps_wx_logging.h
    jeeps/garminusb.h
    jeeps/gpscom.h
    jeeps/gpsdevice.h
    jeeps/gpsinput.h
    jeeps/gpsmem.h
    jeeps/gpsproj.h
    jeeps/gpsread.h
    jeeps/gpssend.h
    jeeps/gpsusbcommon.h
    jeeps/gpsutil.h
    jeeps/garmin_wrapper_utils.h
    jeeps/garmin_wrapper_utils.c
)
if (WIN32)
  set(SRC ${SRC} jeeps/gpsusbwin.c)
  add_definitions(-D__WIN32__)
endif ()
set_source_files_properties(${SRC} PROPERTIES LANGUAGE CXX )

add_library(GARMINHOST STATIC ${SRC})
add_library(ocpn::garminhost ALIAS GARMINHOST)
if (MINGW)
  target_compile_definitions(GARMINHOST PRIVATE "-D_UNICODE")
endif ()

target_compile_definitions(GARMINHOST PRIVATE "-DUSE_WX_LOGGING")
set_property(TARGET GARMINHOST PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(GARMINHOST PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/jeeps)
target_include_directories(GARMINHOST PRIVATE ${wxWidgets_INCLUDE_DIRS})

=== libs/gdal/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::gdal)
    return ()
endif ()

set(SRC
    include/gdal/cpl_config.h
    include/gdal/gdal_priv.h
    include/gdal/cpl_conv.h
    include/gdal/cpl_csv.h
    include/gdal/ogr_api.h
    include/gdal/cpl_error.h
    include/gdal/ogr_attrind.h
    include/gdal/cpl_list.h
    include/gdal/cpl_minixml.h
    include/gdal/ogr_feature.h
    include/gdal/cpl_multiproc.h
    include/gdal/ogr_geometry.h
    include/gdal/cpl_odbc.h
    include/gdal/ogr_p.h
    include/gdal/ogr_core.h
    include/gdal/cpl_port.h
    include/gdal/cpl_string.h
    include/gdal/ogr_spatialref.h
    include/gdal/cpl_vsi.h
    include/gdal/ogrsf_frmts.h
    include/gdal/gdal.h
    include/gdal/gdal_frmts.h
    src/cpl_conv.cpp
    src/cpl_csv.cpp
    src/cpl_error.cpp
    src/cpl_findfile.cpp
    src/cpl_minixml.cpp
    src/cpl_path.cpp
    src/cpl_string.cpp
    src/cpl_vsisimple.cpp
    src/cplgetsymbol.cpp
    src/ograssemblepolygon.cpp
    src/ogrcurve.cpp
    src/ogrfeature.cpp
    src/ogrfeaturedefn.cpp
    src/ogrfielddefn.cpp
    src/ogrgeometry.cpp
    src/ogrgeometrycollection.cpp
    src/ogrgeometryfactory.cpp
    src/ogrlinearring.cpp
    src/ogrlinestring.cpp
    src/ogrmultilinestring.cpp
    src/ogrmultipoint.cpp
    src/ogrmultipolygon.cpp
    src/ogrpoint.cpp
    src/ogrpolygon.cpp
    src/ogrlayer.cpp
    src/ogrutils.cpp
    src/gdal_misc.cpp
)

add_library(GDAL STATIC ${SRC})
add_library(ocpn::gdal ALIAS GDAL)

set_property(TARGET GDAL PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(GDAL BEFORE
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include/gdal
)

=== libs/glu/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(glu)

SET(CMAKE_VERBOSE_MAKEFILE ON)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

#add_definitions(-g -O2 )

IF (NOT WIN32 AND NOT APPLE)
  ADD_DEFINITIONS( "-Wall -Wno-unused -fexceptions -rdynamic" )
  ADD_DEFINITIONS( " -g -fno-strict-aliasing -O2")
ENDIF(NOT WIN32 AND NOT APPLE)

IF(QT_ANDROID)
  ADD_DEFINITIONS( " -fPIC")
ENDIF(QT_ANDROID)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include)
INCLUDE_DIRECTORIES(include)

IF(CMAKE_HOST_WIN32)
    IF(MSVC)
        SET(CMAKE_C_FLAGS_DEBUG               "/MDd /Ob0 /Od  /D_DEBUG  /Zi /RTC1" )
        SET(CMAKE_C_FLAGS_MINSIZEREL          "/MD  /O1  /Ob1 /D NDEBUG")
        SET(CMAKE_C_FLAGS_RELEASE             "/MD  /O2  /Ob2 /D NDEBUG /Zi")
        SET(CMAKE_C_FLAGS_RELWITHDEBINFO      "/MD  /O2  /Ob1 /D NDEBUG /Zi")
        SET(CMAKE_CXX_FLAGS_DEBUG             "/MDd /Ob0 /Od  /D_DEBUG  /Zi /RTC1 /EHa")
        SET(CMAKE_CXX_FLAGS_MINSIZEREL        "/MD  /O1  /Ob1 /D NDEBUG /EHa")
        SET(CMAKE_CXX_FLAGS_RELEASE           "/MD  /O2  /Ob2 /D NDEBUG /Zi /EHa")
        SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO    "/MD  /O2  /Ob1 /D NDEBUG /Zi /EHa" )
        SET(CMAKE_EXE_LINKER_FLAGS "/DEBUG ${CMAKE_EXE_LINKER_FLAGS}")

    ENDIF(MSVC)
ENDIF(CMAKE_HOST_WIN32)

SET(GLU_SOURCES
    libutil/error.c
    libutil/glue.c
#    libutil/quad.c
#    libutil/mipmap.c
    libutil/project.c
    libutil/registry.c
    libtess/tess.c
    libtess/mesh.c
    libtess/priorityq.c
    libtess/sweep.c
    libtess/tessmono.c
    libtess/normal.c
    libtess/memalloc.c
    libtess/geom.c
    libtess/dict.c
    libtess/render.c
    )

add_library(GLU_static STATIC ${GLU_SOURCES})
add_library(glu_static::glu_static ALIAS GLU_static)
set_target_properties(GLU_static PROPERTIES OUTPUT_NAME GLU)

=== libs/sound/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::sound)
    return ()
endif ()

if (NOT CMAKE_MODULE_PATH)
    set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()

set(SRC
    src/OCPN_Sound.cpp
    src/OcpnWxSound.cpp
    src/SoundFactory.cpp
    src/SoundFileLoader.cpp
    src/SoundLoaderFactory.cpp
    src/SystemCmdSound.cpp
    include/OCPN_Sound.h
    include/OcpnWxSound.h
    include/SoundFactory.h
    include/SoundFileLoader.h
    include/SoundLoaderFactory.h
    include/SystemCmdSound.h
)

if (WIN32)
    list(APPEND SRC src/MswSound.cpp include/MswSound.h)
endif ()

if (QT_ANDROID)
    list(APPEND SRC src/AndroidSound.cpp include/AndroidSound.h)
endif ()

if (PORTAUDIO_FOUND)
    list(APPEND SRC include/PortAudioSound.h src/PortAudioSound.cpp)
endif ()

if (LIBSNDFILE_FOUND)
    list(APPEND SRC include/SndfileSoundLoader.h src/SndfileSoundLoader.cpp)
endif ()

add_library(SOUND STATIC ${SRC})
add_library(ocpn::sound ALIAS SOUND)

set_property(TARGET SOUND PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(SOUND
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/include
    PRIVATE
        ${CMAKE_BINARY_DIR}/include
        ${wxWidgets_INCLUDE_DIRS}
        ${CMAKE_CURRENT_BINARY_DIR}/../../include
        ${CMAKE_CURRENT_BINARY_DIR}/../../../include
)

target_link_libraries(SOUND PRIVATE "${SOUND_SUPPORT_LIBS}")

=== libs/sqlite/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ocpn::sqlite)
    return ()
endif ()

if(NOT CMAKE_MODULE_PATH)
  set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif()

add_library(_SQLITE INTERFACE)
add_library(ocpn::sqlite ALIAS _SQLITE)

include(FindSqlite)
if (NOT SQLITE_FOUND OR APPLE OR WIN32 OR QT_ANDROID)
  message(STATUS "Using bundled sqlite3 library.")
  add_library(
    SQLITE3 STATIC
    ${CMAKE_CURRENT_LIST_DIR}/src/sqlite3.c
    ${CMAKE_CURRENT_LIST_DIR}/include/sqlite3.h
  )
  target_link_libraries(_SQLITE INTERFACE SQLITE3)
  target_include_directories(
      _SQLITE INTERFACE ${CMAKE_CURRENT_LIST_DIR}/include
  )

  # We do not need extensions, and using them in a static library causes trouble with libdl linking order.
  if (UNIX AND NOT APPLE)
     add_definitions(" -DSQLITE_OMIT_LOAD_EXTENSION")
  endif (UNIX AND NOT APPLE)

else ()
  target_include_directories(_SQLITE INTERFACE ${SQLITE_INCLUDE_DIR})
  target_link_libraries(_SQLITE INTERFACE ${SQLITE_LIBRARIES})
  file(
    STRINGS "${SQLITE_INCLUDE_DIR}/sqlite3.h" SQLITE_VERSION_LINE
    REGEX "^[ \t]*#define[ \t]+SQLITE_VERSION_NUMBER[ \t]+[0-9]+.*$"
  )
  string(
    REGEX REPLACE
      "[ \t]*#define[ \t]+SQLITE_VERSION_NUMBER[ \t]+([0-9]+).*$"
      "\\1"
      SQLITE_VERSION
      ${SQLITE_VERSION_LINE}
  )
  message(STATUS "Using systrem SQLite library version ${SQLITE_VERSION}.")
  if(${SQLITE_VERSION} LESS "3019000")
      target_compile_definitions(_SQLITE INTERFACE -DSQLITE_USE_LEGACY_STRUCT)
  endif()
endif ()

=== libs/ssl_sha1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if (TARGET ssl::sha1)
    return ()
endif ()

add_library(SHA1 STATIC include/ssl/sha1.h src/sha1.c)
set_property(TARGET SHA1 PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(SHA1 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
add_library(ssl::sha1 ALIAS SHA1)

=== libs/wxservdisc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if (TARGET ocpn::wxservdisc)
    return ()
endif ()

set(SRC
  mdnsd.c
  1035.c
  wxServDisc.cpp
  )

add_library(WXSERVDISC STATIC ${SRC})
add_library(ocpn::wxservdisc ALIAS WXSERVDISC)

set_property(TARGET WXSERVDISC PROPERTY COMPILE_FLAGS "${OBJ_VISIBILITY}")
target_include_directories(WXSERVDISC PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_compile_options(WXSERVDISC PRIVATE -Wno-pointer-sign -Wno-parentheses)
endif ()

if (WIN32)
  target_link_libraries(WXSERVDISC PRIVATE ws2_32)
endif ()

=== plugins/chartdldr_pi/CMakeLists.txt ===
# ---------------------------------------------------------------------------
# Author:      Pavel Kalian Copyright:   2014 License:     GPLv2 License
# ---------------------------------------------------------------------------

# define minimum cmake version
cmake_minimum_required(VERSION 3.1.1)
cmake_policy(SET CMP0043 NEW)

project(chartdldr_pi)

set(PACKAGE_NAME chartdldr_pi)
set(VERBOSE_NAME ChartDownloader)
set(TITLE_NAME ChartDownloader)
set(CPACK_PACKAGE_CONTACT "Pavel Kalian")

set(VERSION_MAJOR "1")
set(VERSION_MINOR "4")
set(VERSION_PATCH "0")
set(VERSION_DATE "2019-12-09")

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      Release
      CACHE
        STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE
  )
endif (NOT CMAKE_BUILD_TYPE)

include_directories(${CMAKE_SOURCE_DIR}/include)

message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

# SET(CMAKE_BUILD_TYPE Debug)
set(CMAKE_MACOSX_RPATH "ON")

include("cmake/PluginConfigure.cmake")

set(SRC_CHARTDLDR
    src/chartdldr_pi.h
    src/chartdldr_pi.cpp
    src/icons.h
    src/icons.cpp
    src/chartdldrgui.h
    src/chartdldrgui.cpp
    # src/checkedlistctrl.cpp src/checkedlistctrl.h
    src/base64.h
    src/chartcatalog.cpp
    src/chartcatalog.h
    src/pugiconfig.hpp
    src/pugixml.hpp
    src/pugixml.cpp
)

if (QT_ANDROID)
  set(SRC_CHARTDLDR ${SRC_CHARTDLDR} src/androidSupport.h)
  set(SRC_CHARTDLDR ${SRC_CHARTDLDR} src/androidSupport.cpp)
endif (QT_ANDROID)

set(SRC_UNARR
    src/unarr/common/conv.c
    src/unarr/common/crc32.c
    src/unarr/common/custalloc.c
    src/unarr/common/allocator.h
    src/unarr/common/unarr.c
    src/unarr/common/unarr-imp.h
    src/unarr/common/stream.c
    src/unarr/_7z/_7z.h
    src/unarr/_7z/_7z.c
    src/unarr/lzmasdk/Ppmd7Dec.c
    src/unarr/lzmasdk/Ppmd8.h
    src/unarr/lzmasdk/7zTypes.h
    src/unarr/lzmasdk/Precomp.h
    src/unarr/lzmasdk/CpuArch.h
    src/unarr/lzmasdk/Ppmd7.c
    src/unarr/lzmasdk/LzmaDec.c
    src/unarr/lzmasdk/Ppmd8.c
    src/unarr/lzmasdk/Ppmd.h
    src/unarr/lzmasdk/Ppmd7.h
    src/unarr/lzmasdk/CpuArch.c
    src/unarr/lzmasdk/LzmaDec.h
    src/unarr/lzmasdk/Ppmd8Dec.c
    src/unarr/rar/filter-rar.c
    src/unarr/rar/huffman-rar.c
    src/unarr/rar/parse-rar.c
    src/unarr/rar/rar.h
    src/unarr/rar/rarvm.c
    src/unarr/rar/uncompress-rar.c
    src/unarr/rar/rarvm.h
    src/unarr/rar/lzss.h
    src/unarr/rar/rar.c
    src/unarr/unarr.h
    src/unarr/tar/tar.h
    src/unarr/tar/parse-tar.c
    src/unarr/tar/tar.c
    src/unarr/zip/uncompress-zip.c
    src/unarr/zip/inflate.c
    src/unarr/zip/zip.c
    src/unarr/zip/parse-zip.c
    src/unarr/zip/zip.h
    src/unarr/zip/inflate.h
)

if (APPLE)
  # Homebrew does not link libarchive to /usr/local by default to avoid conflict
  # with the system-wide one (which in turn does not provide includes...) We do
  # not want the systemwide vrsion as it is too old and misses support for many
  # archive formats
  list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/libarchive")
  list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/libarchive/lib")
endif ()

if (CMAKE_HOST_WIN32)
  list(APPEND CMAKE_PREFIX_PATH "../../buildwin/include")
  list(APPEND CMAKE_PREFIX_PATH "../../buildwin")
endif ()

option(OCPN_USE_CHART_LIST "Use wxDATAVIEWLISTCTRL for chart downloader" OFF)
if (MSVC)
  set(OCPN_USE_CHART_LIST ON)
endif (MSVC)

if (wxWidgets_VERSION_STRING GREATER 2.9)
  if (OCPN_USE_CHART_LIST)
    add_definitions(-DCHART_LIST)
    message(
      STATUS "chartdldr_pi: Building with wxDATAVIEWLISTCTRL chart listing"
    )
  else (wxWidgets_VERSION_STRING GREATER 2.9)
    message(
      STATUS "chartdldr_pi: Building without wxDATAVIEWLISTCTRL chart listing"
    )
  endif (OCPN_USE_CHART_LIST)
endif (wxWidgets_VERSION_STRING GREATER 2.9)

option(CHARTDLDR_USE_UNARR
       "Use unarr to extract RAR archives instead of libarchive" ON
)
if (CHARTDLDR_USE_UNARR)
  add_definitions(-DCHARTDLDR_RAR_UNARR)
endif ()

add_definitions(-D_FILE_OFFSET_BITS=64)

include_directories(src/unarr/)
pkg_search_module(UNARR libunarr unarr)
use_bundled_lib(USE_BUNDLED_UNARR unarr)
if (UNARR_FOUND AND NOT USE_BUNDLED_UNARR)
  message(STATUS "chartdldr_pi: Building with system unarr")
  include_directories(${UNARR_INCLUDE_DIR})
  set(SRC_UNARR "")
else ()
  message(STATUS "chartdldr_pi: Building with bundled unarr")
  add_library(UNARR ${SRC_UNARR})
  include_directories(src/unarr)
endif ()

add_library(${PACKAGE_NAME} SHARED ${SRC_UNARR} ${SRC_CHARTDLDR})

if (QT_ANDROID)
  target_include_directories(
    ${PACKAGE_NAME} PRIVATE ${CMAKE_SOURCE_DIR}/buildandroid/libarchive/include
  )
  target_link_libraries(
    ${PACKAGE_NAME}
    PRIVATE ${CMAKE_SOURCE_DIR}/buildandroid/libarchive/${ARCH}/libarchive.a
  )
elseif (APPLE)
  if (OCPN_USE_SYSTEM_LIBARCHIVE)
    list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/libarchive")
    find_package(LibArchive REQUIRED)
    target_include_directories(
      ${PACKAGE_NAME} PRIVATE ${LibArchive_INCLUDE_DIRS}
    )
    target_link_libraries(${PACKAGE_NAME} PRIVATE ${LibArchive_LIBRARIES})
    # If we use system libarchive, we do not bundel the dylib and need to
    # comment it out from the pkg project file
    set(LIBARCHIVE_COMMENT_START "<!--")
    set(LIBARCHIVE_COMMENT_END "-->")
  else ()
    # TODO This is a hack, due to the way libarchive is built and installed in
    # CI build environment
    set(LibArchive_INCLUDE_DIRS /opt/local/include)
    set(LibArchive_LIBRARIES /opt/local/lib/libarchive.dylib)
    set(LibArchive_FOUND 1)
  endif ()
else ()
  find_package(LibArchive REQUIRED)
  target_include_directories(${PACKAGE_NAME} PRIVATE ${LibArchive_INCLUDE_DIRS})
  target_link_libraries(${PACKAGE_NAME} PRIVATE ${LibArchive_LIBRARIES})
endif (QT_ANDROID)

# FIND_PACKAGE(LibArchive)
if (LibArchive_FOUND)
  message(STATUS "chartdldr_pi: going to use LibArchive...")
  message(STATUS "chartdldr_pi: " ${LibArchive_INCLUDE_DIRS})
  message(STATUS "chartdldr_pi: " ${LibArchive_LIBRARIES})
  include_directories(${LibArchive_INCLUDE_DIRS})
  # Unset the unrar sources as we will not need them
  add_definitions(-DDLDR_USE_LIBARCHIVE)
endif (LibArchive_FOUND)

if (QT_ANDROID)
  add_definitions(-D__STDC_LIMIT_MACROS)
  add_definitions(-D__STDC_CONSTANT_MACROS)
  add_definitions(
    "-Wno-inconsistent-missing-override -Wno-potentially-evaluated-expression"
  )
endif (QT_ANDROID)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|AppleClang")
  # FIXME: This is to broad, needs better handling after 5.0.0
  target_compile_options(${PACKAGE_NAME} PRIVATE -Wno-overloaded-virtual)
  target_compile_options(${PACKAGE_NAME} PRIVATE -Wno-unknown-pragmas)
  target_compile_options(${PACKAGE_NAME} PRIVATE -Wno-unused-variable)
endif ()

if (UNARR_LIBRARIES AND NOT USE_BUNDLED_UNARR)
  target_link_libraries(${PACKAGE_NAME} PRIVATE ${UNARR_LIBRARIES})
endif ()

if (LibArchive_FOUND)
  target_link_libraries(${PACKAGE_NAME} PRIVATE ${LibArchive_LIBRARIES})
else (LibArchive_FOUND)
  # We do not have libarchive, try to make unarr more powerful...
  # ADD_DEFINITIONS(-DHAVE_7Z) #TODO if we decide it is needed, quite a bit more
  # work here
  find_package(ZLIB)
  if (ZLIB_FOUND)
    add_definitions(-DHAVE_ZLIB)
    include_directories(${ZLIB_INCLUDE_DIRS})
    target_link_libraries(${PACKAGE_NAME} PRIVATE ${ZLIB_LIBRARIES})
  endif (ZLIB_FOUND)
  find_package(BZip2)
  if (BZIP2_FOUND)
    add_definitions(-DHAVE_BZIP2)
    include_directories(${BZIP2_INCLUDE_DIRS})
    target_link_libraries(${PACKAGE_NAME} PRIVATE ${BZIP2_LIBRARIES})
  endif (BZIP2_FOUND)
endif (LibArchive_FOUND)

# TARGET_LINK_LIBRARIES( ${PACKAGE_NAME} PRIVATE wxjson::wxjson )

# target_link_libraries( ${PACKAGE_NAME} PRIVATE ${OPENCPN_LINK_TARGET} )

if (NOT QT_ANDROID)
  target_link_libraries(
    ${PACKAGE_NAME} PRIVATE ${wxWidgets_LIBRARIES} ocpn::wxjson ocpn::wxsvg
                            ocpn::opencpn
  )
else (NOT QT_ANDROID)
  target_link_libraries(
    ${PACKAGE_NAME}
    PRIVATE ocpn::wxjson
            ${Qt_Base}/${Qt_Build}/lib/libQt5Gui.so
            ${Qt_Base}/${Qt_Build}/lib/libQt5Core.so
            ${Qt_Base}/${Qt_Build}/lib/libQt5Widgets.so
            ${Qt_Base}/${Qt_Build}/lib/libQt5AndroidExtras.so
            ${CMAKE_CURRENT_BINARY_DIR}/../../libgorp.so
            "-lz"
  )

  set(CMAKE_SHARED_LINKER_FLAGS "-Wl,-soname,lib${PACKAGE_NAME}.so ")
  # SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-s")
endif (NOT QT_ANDROID)

if (APPLE)
  target_compile_options(
    ${PACKAGE_NAME}
    PRIVATE "-Wall"
            "-Wno-unused"
            "-fexceptions"
            "-Wno-overloaded-virtual"
            "-Wno-deprecated"
            "-Wno-deprecated-declarations"
            "-Wno-unknown-pragmas"
            "-D_WCHAR_H_CPLUSPLUS_98_CONFORMANCE_"
  )
endif (APPLE)

# Copy shared library to execution folder for debugging if not CI build
if (NOT OCPN_CI_BUILD)
  if (MSVC)
    add_custom_command(
      TARGET ${PACKAGE_NAME}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E echo "Copying dll file"
      COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_FILE:${PACKAGE_NAME}>"
              "${CMAKE_BINARY_DIR}/$(configuration)/plugins"
      COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:${PACKAGE_NAME}>"
              "${CMAKE_BINARY_DIR}/$(configuration)/plugins"
    )
    if (CMAKE_BUILD_TYPE MATCHES "Debug")
      add_custom_command(
        TARGET ${PACKAGE_NAME}
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E echo "Copying pdb file"
        COMMAND
          ${CMAKE_COMMAND} -E echo "$<TARGET_PDB_FILE_NAME:${PACKAGE_NAME}>"
          "${CMAKE_BINARY_DIR}/$(configuration)/plugins"
        COMMAND
          ${CMAKE_COMMAND} -E copy "$<TARGET_PDB_FILE_NAME:${PACKAGE_NAME}>"
          "${CMAKE_BINARY_DIR}/$(configuration)/plugins"
      )
    endif ()
  endif (MSVC)
endif (NOT OCPN_CI_BUILD)

include("cmake/PluginInstall.cmake")
include("cmake/PluginLocalization.cmake")
include("cmake/PluginPackage.cmake")

=== debian/changelog ===
opencpn (5.6.2+dfsg-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Initial buster  backport of 5.6.2+dfsg2.
  * Rebase and renumber patches.
  * Add 1.2M patch restoring bundled wxsvg library since system
    libwxsvg is not available on buster (handled by repacking in 5.6.0).

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 26 Apr 2022 18:11:07 +0200

opencpn (5.6.0+dfsg0-1~bpo10+2) buster-backports-sloppy; urgency=medium

  * Link to gtk2 instead of gtk3 to match available plugins.
    Closes: #1009701
  * Add upstream patches to make it possible to define the target as
    a compile time constant.
  * Add patch to avoid getting multiple possible plugins to load besides
    the Debian version.

 -- Alec Leamas <leamas.alec@gmail.com>  Wed, 13 Apr 2022 18:11:14 +0200

opencpn (5.6.0+dfsg0-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy.
  * Update VCS urls and gbp.conf default branch
  * Downgrade debhelper compat, 13 -> 12
  * Drop libwxsvg build dep
  * Don't strip libwxsvg in d/copyright, repack sources with bundled
    library in place. Use dfsg0 to make it precede dfsg1 in bullseye.

 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 30 Dec 2021 17:52:50 +0100

=== debian/control ===
Source: opencpn
Maintainer: Alec Leamas <leamas.alec@gmail.com>
Section: misc
Priority: optional
Build-Depends: debhelper-compat (= 12),
 cmake,
 libarchive-dev,
 libbz2-dev,
 libcurl4-gnutls-dev | libcurl4-openssl-dev,
 libdrm-dev,
 libelf-dev,
 libexif-dev,
 libgdk-pixbuf2.0-dev,
 libgtk2.0-dev,
 liblz4-dev,
 liblzma-dev,
 libpango1.0-dev,
 libsqlite3-dev,
 libtinyxml-dev,
 libudev-dev,
 libunarr-dev,
 libusb-1.0-0-dev,
 libwxgtk3.0-dev,
 lsb-release,
 portaudio19-dev
Standards-Version: 4.6.0
Vcs-Browser: https://gitlab.com/leamas/opencpn
Vcs-Git: https://gitlab.com/leamas/opencpn.git -b debian/buster-sloppy
Homepage: https://opencpn.org
Rules-Requires-Root: no

Package: opencpn
Architecture: any
Depends: opencpn-data (>= ${source:Version}),
 bzip2,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: wx3.0-i18n
Breaks: opencpn-plugins (<< 4.8.8~)
Replaces: opencpn-plugins (<< 4.8.8~)
Suggests: binutils
Description: Open Source Chartplotter and Marine GPS Navigation Software
 Chart Plotter and Navigational software program for use underway
 or as a planning tool. Developed by a team of active sailors using real
 world conditions for program testing and refinement.
 By default supports raster and vector formats like BSB and S63. Support for
 many other formats are available in plugins. Other plugins provides
 support for e. g., AIS, radar and weather maps.
 Application has language support in 20+ languages.
 .
 This package contains programs, libraries and some support files.

Package: opencpn-data
Architecture: all
Depends: ${misc:Depends}
Description: Open Source Chartplotter and Marine GPS Navigation Software (data)
 Chart Plotter and Navigational software program for use underway
 or as a planning tool. Developed by a team of active sailors using real
 world conditions for program testing and refinement.
 By default supports raster and vector formats like BSB and S63. Support for
 many other formats are available in plugins. Other plugins provides
 support for e. g., AIS, radar and weather maps.
 Application has language support in 20+ languages.
 .
 This package contains architecture independent data files.

=== debian/rules ===
#!/usr/bin/make -f

include  /usr/share/dpkg/pkg-info.mk
include  /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

TARGET      = $(subst amd64,x86_64,$(DEB_HOST_ARCH))

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_INSTALL_LIBDIR=/usr/lib \
            -DBUILD_SHARED_LIBS=OFF \
	    -DOCPN_BUNDLE_DOCS=OFF \
            -DOCPN_BUNDLE_TCDATA=ON \
            -DOCPN_USE_BUNDLED_LIBS=OFF \
            -DOCPN_USE_NEWSERIAL=OFF \
            -DOCPN_PLUGIN_CONTENTS_WARN=ON \
	    -DOCPN_FORCE_GTK3=OFF \
	    -DOCPN_TARGET_TUPLE="debian-$(TARGET);10;$(TARGET)"

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg0|ds|deb)\.?\d*$//,\
filenamemangle=s/_(Release|Beta|Alpha|v|V)//;s|^.*tags/|opencpn-|;,\
uversionmangle=s/((Beta|Alpha|v|V|Release)[\.\-\+_]?)?//;,\
repacksuffix=+dfsg0 \
https://github.com/OpenCPN/OpenCPN/tags \
.*/(Beta|OA|v|V|Release)_([\d\.]+).zip

## opencpn 5.8.4%2Bdfsg

=== libs/wxcurl/CMakeLists.txt ===
--- 
+++ 
@@ -46,12 +46,14 @@
 
 add_library(WXCURL STATIC ${SRC})
 add_library(ocpn::wxcurl ALIAS WXCURL)
-set_property(TARGET WXCURL PROPERTY COMPILE_FLAGS "-fvisibility=default")
+if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
+  set_property(TARGET WXCURL PROPERTY COMPILE_FLAGS "-fvisibility=default")
+endif ()
 target_include_directories(WXCURL
     PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
     PUBLIC ${CURL_INCLUDE_DIRS}
 )
-target_link_libraries(WXCURL ${CURL_LIBRARIES})
+target_link_libraries(WXCURL ${CURL_LIBRARIES})# ${wxWidgets_LIBRARIES})
 if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|AppleClang|GNU")
   target_compile_options(WXCURL  PRIVATE "-Wno-unknown-pragmas")
 endif ()

=== debian/changelog ===
opencpn (5.8.4+dfsg-1~bpo11+1) bullseye-backports-sloppy; urgency=medium

  * New upstream-release
  * Rebuilt for bullseye-backports-sloppy.

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 21 Jul 2023 10:27:57 +0200

opencpn (5.8.2+dfsg-3) unstable; urgency=medium

  * d/rules: Try to fix test target on armhf et. al.

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 05 May 2023 15:45:02 +0200

opencpn (5.8.2+dfsg-2) unstable; urgency=medium

  * Add Depends: for jslib packages. Closes: #1034582.
  * opencpn uses wxWidgets 3.2 since 5.8.2+dfsg-1. Closes: #1019769

 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 05 May 2023 15:11:38 +0200

opencpn (5.8.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Drop upstreamed patches

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 02 May 2023 17:23:43 +0200

opencpn (5.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Drop upstreamed patches, rebase remaining
  * Exclude MathJax and highlight js libraries, use packages instead.
  * Add new build deps:
     - libssl-dev
     - googletest
     - libglew-dev
     - repidjson-dev
     - libjs-highlight.js
     - libjs-mathjax
  * Update deprecated libpixbuf-dev build dep
  * Update d/copyright using cme.


 -- Alec Leamas <leamas.alec@gmail.com>  Fri, 14 Apr 2023 09:37:20 +0200

opencpn (5.6.2+dfsg-2) unstable; urgency=medium

  * New bugfix release.
  * New patches, all applied upstream:
     - Fix upstream bug https://github.com/OpenCPN/OpenCPN/issues/2750
     - Handle tracking started before toolbar exists
     - Chart groups out of bounds access fix.
     - Allow GPX track point without time.
  * d/copyright: Remove more files when repackaging

 -- Alec Leamas <leamas.alec@gmail.com>  Thu, 01 Sep 2022 14:33:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,30 +2,39 @@
 Maintainer: Alec Leamas <leamas.alec@gmail.com>
 Section: misc
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  cmake,
+ googletest,
  libarchive-dev,
  libbz2-dev,
  libcurl4-gnutls-dev | libcurl4-openssl-dev,
+ libcxx-serial-dev,
  libdrm-dev,
  libelf-dev,
  libexif-dev,
- libgdk-pixbuf2.0-dev,
- libgtk2.0-dev,
+ libgdk-pixbuf-2.0-dev,
+ libglew-dev,
+ libgtk-3-dev,
+ libjs-highlight.js,
+ libjs-mathjax,
  liblz4-dev,
  liblzma-dev,
  libpango1.0-dev,
  libsqlite3-dev,
+ libssl-dev,
  libtinyxml-dev,
  libudev-dev,
  libunarr-dev,
  libusb-1.0-0-dev,
- libwxgtk3.0-dev,
+ libwxsvg-dev (>= 2:1.5.21),
+ libwxgtk3.2-dev | libwxgtk3.0-gtk3-dev,
+ libwxgtk-webview3.2-dev | libwxgtk-webview3.0-gtk3-dev,
  lsb-release,
- portaudio19-dev
+ portaudio19-dev,
+ rapidjson-dev
 Standards-Version: 4.6.0
 Vcs-Browser: https://gitlab.com/leamas/opencpn
-Vcs-Git: https://gitlab.com/leamas/opencpn.git -b debian/buster-sloppy
+Vcs-Git: https://gitlab.com/leamas/opencpn.git -b debian/sid
 Homepage: https://opencpn.org
 Rules-Requires-Root: no
 
@@ -33,6 +42,8 @@
 Architecture: any
 Depends: opencpn-data (>= ${source:Version}),
  bzip2,
+ libjs-mathjax,
+ libjs-highlight.js,
  ${shlibs:Depends},
  ${misc:Depends}
 Recommends: wx3.0-i18n
@@ -52,6 +63,7 @@
 
 Package: opencpn-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Open Source Chartplotter and Marine GPS Navigation Software (data)
  Chart Plotter and Navigational software program for use underway

=== debian/rules ===
#!/usr/bin/make -f

include  /usr/share/dpkg/architecture.mk

ifeq ($(DEB_TARGET_ARCH),amd64)
  TARGET_ARCH = x86_64
else
  TARGET_ARCH = $(DEB_TARGET_ARCH)
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_BUILD_TYPE=RelWithDebInfo \
            -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
            -DCMAKE_INSTALL_LIBDIR=/usr/lib \
            -DBUILD_SHARED_LIBS=OFF \
            -DOCPN_BUNDLE_DOCS=OFF \
            -DOCPN_BUNDLE_TCDATA=ON \
            -DOCPN_USE_BUNDLED_LIBS=OFF \
            -DOCPN_USE_NEWSERIAL=ON \
            -DOCPN_PLUGIN_CONTENTS_WARN=ON \
            -DOCPN_TARGET_TUPLE="debian-$(TARGET_ARCH);11;$(TARGET_ARCH)" \
	    -DOCPN_BUILD_TEST=OFF

override_dh_auto_test:
	cd obj-*-linux-gnu*; make run-tests
